# Hydrogen : An alternative to Jupyter

## Installation

[Hydrogen](https://nteract.io/) is an extension for [Atom](https://atom.io/) editor. It works with [Jupyter](https://jupyter.org/) and multiple languages.

To install atom use the link above to download atom. I recommand to use conda to install python and jupyter. Install the last nodejs version from [here](https://nodejs.org/en/).

Once you have installed Jupyter, Node and Atom you can install hydrogen :

```bash
apm install hydrogen
```

## Usage

For each language you have to install the grammar in Atom and the kernel in Jupyter. For the most common languages it's generally easy to find both.

### Example

To install allow Hydrogen to handle the Kotlin language, I search `language kotlin` in the package manager of atom (menu `Edit > Preferences > Install`).

I found this one [atom-kotlin-language](https://github.com/alexmt/atom-kotlin-language). You must verify that the package contains the language grammar. If you know the package name you can install it with apm (Atom package manager) :

```bash
apm install language-kotlin
```

After that I install the kotlin kernel available on [github](https://github.com/Kotlin/kotlin-jupyter):

```bash
conda install kotlin-jupyter-kernel -c jetbrains
```

When the both tasks are done you can know execute the code in block comments by pressing `Ctrl + Enter` in the block section :

```python
print("Hello World")
```

```markdown
​```kotlin
println("Hello World")
​```
```

![Kotlin run example](run_kt.png)

You can use multiple languages in the same document, as the kernel is choose by the language name, i.e. the code block :

<pre><code class="markdown">
    ```python
    print('Ok') # Use python kernel
    ```
    ```kotlin
    println("Ok") // Use kotlin kernel
    ```
</code></pre>

You can find an usage example at [usage](example.md) and view the [result in the IDE](example.png)
